Debian Bug report logs - #627439
support for two-pass manifests

version graph

Package: live-build; Maintainer for live-build is Live Systems Maintainers <debian-live@lists.debian.org>; Source for live-build is src:live-build.

Reported by: Colin Watson <cjwatson@ubuntu.com>

Date: Fri, 20 May 2011 16:27:01 UTC

Severity: wishlist

Found in version live-build/3.0~a17-1

Fixed in version live-build/3.0~a20-1

Done: Daniel Baumann <daniel@debian.org>

Bug is archived. No further changes may be made.

Toggle useless messages

View this report as an mbox folder, status mbox, maintainer mbox


Report forwarded to debian-bugs-dist@lists.debian.org, Debian Live Project <debian-live@lists.debian.org>:
Bug#627439; Package live-build. (Fri, 20 May 2011 16:27:04 GMT) Full text and rfc822 format available.

Acknowledgement sent to Colin Watson <cjwatson@ubuntu.com>:
New Bug report received and forwarded. Copy sent to Debian Live Project <debian-live@lists.debian.org>. (Fri, 20 May 2011 16:27:04 GMT) Full text and rfc822 format available.

Message #5 received at submit@bugs.debian.org (full text, mbox):

From: Colin Watson <cjwatson@ubuntu.com>
To: submit@bugs.debian.org
Subject: handling Ubuntu's multiple manifest scheme
Date: Fri, 20 May 2011 17:25:46 +0100
Package: live-build
Version: 3.0~a17-1
Severity: wishlist
User: ubuntu-devel@lists.ubuntu.com
Usertags: origin-ubuntu oneiric

I'm looking for some guidance on one of the remaining major pieces
involved in making live-build usable for official Ubuntu live filesystem
builds.

Most package installation in our current live filesystem builds is done
in two stages.  The first corresponds to the packages that should be
copied to an installed system when installing from the live CD, and the
second corresponds to the packages that may need to be removed from the
installed system: this includes live CD boot infrastructure, the
installer itself, and other bits and pieces such as language packs.  At
the end of the first stage, we write out filesystem.manifest-desktop; at
the end of the second stage, we write out filesystem.manifest.

After copying files to disk, the installer takes the set of packages in
filesystem.manifest but not in filesystem.manifest-desktop, eliminates
any packages from that set that some bit of the installer explicitly
asked to keep (for example, we might as well keep the language packs
corresponding to the user's language rather than making them reinstall
them from the network), and removes that set of packages from disk.

live-build doesn't currently support this kind of two-stage installation
except by means of local hooks, and as explained in
http://bugs.debian.org/cgi-bin/bugreport.cgi?bug=627332#25 I would like
to find a way to do this without local hooks.  I'm happy to do the
implementation work, but do you have any ideas on a nice way to do this
within the structure of live-build?

There is of course the possibility of not bothering with a two-stage
installation, and instead computing filesystem.manifest-desktop
independently.  I'm reluctant to take this approach because it would
carry risk of archive skew and/or simple coding errors resulting in
filesystem.manifest-desktop not matching what apt would have installed
at that point in a hypothetical two-stage installation; but it's an
option if you think this just won't fit.

Thanks,

-- 
Colin Watson                                       [cjwatson@ubuntu.com]




Information forwarded to debian-bugs-dist@lists.debian.org, Debian Live Project <debian-live@lists.debian.org>:
Bug#627439; Package live-build. (Fri, 10 Jun 2011 11:06:21 GMT) Full text and rfc822 format available.

Acknowledgement sent to Colin Watson <cjwatson@ubuntu.com>:
Extra info received and forwarded to list. Copy sent to Debian Live Project <debian-live@lists.debian.org>. (Fri, 10 Jun 2011 11:06:29 GMT) Full text and rfc822 format available.

Message #10 received at 627439@bugs.debian.org (full text, mbox):

From: Colin Watson <cjwatson@ubuntu.com>
To: 627439@bugs.debian.org
Subject: Re: handling Ubuntu's multiple manifest scheme
Date: Fri, 10 Jun 2011 12:03:21 +0100
[Message part 1 (text/plain, inline)]
On Fri, May 20, 2011 at 05:25:45PM +0100, Colin Watson wrote:
> live-build doesn't currently support this kind of two-stage installation
> except by means of local hooks, and as explained in
> http://bugs.debian.org/cgi-bin/bugreport.cgi?bug=627332#25 I would like
> to find a way to do this without local hooks.  I'm happy to do the
> implementation work, but do you have any ideas on a nice way to do this
> within the structure of live-build?

I've ended up with the attached patch for now.  How does this look?  As
discussed on IRC, I guess you'll want a different way to handle package
lists; I'm only using tasks and a couple of individual packages, so I'm
not really well-placed to judge how package lists might work here.

-- 
Colin Watson                                       [cjwatson@ubuntu.com]
[0001-Add-live-package-lists-live-packages-and-live-tasks-.patch (text/x-diff, attachment)]

Information forwarded to debian-bugs-dist@lists.debian.org, Debian Live Project <debian-live@lists.debian.org>:
Bug#627439; Package live-build. (Sat, 11 Jun 2011 15:48:03 GMT) Full text and rfc822 format available.

Acknowledgement sent to daniel.baumann@progress-technologies.net:
Extra info received and forwarded to list. Copy sent to Debian Live Project <debian-live@lists.debian.org>. (Sat, 11 Jun 2011 15:48:03 GMT) Full text and rfc822 format available.

Message #15 received at 627439@bugs.debian.org (full text, mbox):

From: Daniel Baumann <daniel.baumann@progress-technologies.net>
To: Colin Watson <cjwatson@ubuntu.com>
Cc: 627439@bugs.debian.org
Subject: Re: Bug#627439: handling Ubuntu's multiple manifest scheme
Date: Sat, 11 Jun 2011 17:45:09 +0200
retitle 627439 support for two-pass manifests
tag 627439 pending
thanks

On 06/10/2011 01:03 PM, Colin Watson wrote:
> I've ended up with the attached patch for now.  How does this look?  As
> discussed on IRC, I guess you'll want a different way to handle package
> lists; I'm only using tasks and a couple of individual packages, so I'm
> not really well-placed to judge how package lists might work here.

[...]
2011-06-09 17:12:09 < dba> for live-installer, it's dead simple.. we 
would just read in something like /cdrom/live/filesystem.remove or something
[...]
2011-06-09 17:22:50 < dba> so.. live-installer should support removing 
that stuff now (untested; therefore on daniel branch).
[...]
2011-06-09 17:28:21 < cjwatson> I have an instinctive dislike for 
listing the packages to remove rather than the packages to keep, 
although I'm not sure I can articulate why so perhaps that's bogus
2011-06-09 17:28:35 < cjwatson> may just be inertia
2011-06-09 17:30:13 < dba> specifying which to remove is more natural, 
and shorter.
2011-06-09 17:30:35 < dba> also, it's human readable.
2011-06-09 17:31:04 < dba> if listing only those to keep, i can't tell 
which packages are different between live and install just from looking 
at the list on the media.
[...]
2011-06-09 17:34:03 < dba> regarding live-build, how about this:
2011-06-09 17:34:48 < dba> if we have 
config/chroot_local-packagelists/*.{install,live}, then install the 
'install' ones first,
2011-06-09 17:35:32 < dba> dump out a package list, then install the 
'live' ones, dump out a package list. later diff the dumps in whatever 
way is suitable for debian/ubuntu.
[...]
2011-06-09 17:36:10 < dba> if we have no 
config/chroot_local-packagelists/*.{install,live} (just anything with 
*.list), then behave as normal (one pass).
2011-06-09 17:36:34 < dba> (where 
config/chroot_local-packagelists/*.{install,live} should be 
config/chroot_local-packagelists/*.list.{install,live}, but you get the 
idea)
2011-06-09 17:37:17 < dba> otoh, this only works based on the assumption 
that #install << #live


done and pushed what i said above in 238ae93.

-- 
Address:        Daniel Baumann, Donnerbuehlweg 3, CH-3012 Bern
Email:          daniel.baumann@progress-technologies.net
Internet:       http://people.progress-technologies.net/~daniel.baumann/




Changed Bug title to 'support for two-pass manifests' from 'handling Ubuntu's multiple manifest scheme' Request was from Daniel Baumann <daniel.baumann@progress-technologies.net> to control@bugs.debian.org. (Sat, 11 Jun 2011 15:48:04 GMT) Full text and rfc822 format available.

Added tag(s) pending. Request was from Daniel Baumann <daniel.baumann@progress-technologies.net> to control@bugs.debian.org. (Sat, 11 Jun 2011 15:48:05 GMT) Full text and rfc822 format available.

Reply sent to Daniel Baumann <daniel@debian.org>:
You have taken responsibility. (Sat, 11 Jun 2011 16:21:07 GMT) Full text and rfc822 format available.

Notification sent to Colin Watson <cjwatson@ubuntu.com>:
Bug acknowledged by developer. (Sat, 11 Jun 2011 16:21:07 GMT) Full text and rfc822 format available.

Message #24 received at 627439-close@bugs.debian.org (full text, mbox):

From: Daniel Baumann <daniel@debian.org>
To: 627439-close@bugs.debian.org
Subject: Bug#627439: fixed in live-build 3.0~a20-1
Date: Sat, 11 Jun 2011 16:18:12 +0000
Source: live-build
Source-Version: 3.0~a20-1

We believe that the bug you reported is fixed in the latest version of
live-build, which is due to be installed in the Debian FTP archive:

live-build-cgi_3.0~a20-1_all.deb
  to main/l/live-build/live-build-cgi_3.0~a20-1_all.deb
live-build_3.0~a20-1.debian.tar.gz
  to main/l/live-build/live-build_3.0~a20-1.debian.tar.gz
live-build_3.0~a20-1.dsc
  to main/l/live-build/live-build_3.0~a20-1.dsc
live-build_3.0~a20-1_all.deb
  to main/l/live-build/live-build_3.0~a20-1_all.deb
live-build_3.0~a20.orig.tar.gz
  to main/l/live-build/live-build_3.0~a20.orig.tar.gz



A summary of the changes between this version and the previous one is
attached.

Thank you for reporting the bug, which will now be closed.  If you
have further comments please address them to 627439@bugs.debian.org,
and the maintainer will reopen the bug report if appropriate.

Debian distribution maintenance software
pp.
Daniel Baumann <daniel@debian.org> (supplier of updated live-build package)

(This message was generated automatically at their request; if you
believe that there is a problem with it please contact the archive
administrators by mailing ftpmaster@debian.org)


-----BEGIN PGP SIGNED MESSAGE-----
Hash: SHA1

Format: 1.8
Date: Sat, 11 Jun 2011 17:46:24 +0200
Source: live-build
Binary: live-build live-build-cgi
Architecture: source all
Version: 3.0~a20-1
Distribution: unstable
Urgency: low
Maintainer: Debian Live Project <debian-live@lists.debian.org>
Changed-By: Daniel Baumann <daniel@debian.org>
Description: 
 live-build - Debian Live - System Build Scripts
 live-build-cgi - Debian Live - System Build Scripts (cgi frontend)
Closes: 627439 630032 630043 630080
Changes: 
 live-build (3.0~a20-1) unstable; urgency=low
 .
   [ Daniel Baumann ]
   * Dropping handling of --packages in order to simply things handle
     packages scheduled for installation through package lists only.
   * Removing unmaintained chroot_localization script.
 .
   [ Colin Watson ]
   * Use powerpc and powerpc64-smp kernel flavours by default for Ubuntu,
     as there is no powerpc64 flavour (Closes: #630032).
 .
   [ Daniel Baumann ]
   * Correct indenting in powerpc kernel defaults.
 .
   [ Colin Watson ]
   * Use dpkg --force-unsafe-io if available (Closes: #630043).
 .
   [ Daniel Baumann ]
   * Correcting indenting for dpkg sync configuration file.
   * Always disable dpkg sync, we only support squeeze and newer anyway.
 .
   [ Colin Watson ]
   * Fix incorrect Ubuntu defaults for security and volatile mirrors
     (Closes: #630080).
 .
   [ Daniel Baumann ]
   * Reworking chroot_tasks into chroot_local-tasklists, now packages and
     tasks are (almost) handled identical and through local lists only.
   * Creating chroot_local-tasklists directory in config.
   * Using locales-all instead of locales in standard list for progress.
   * Adding support for 'nif' in package lists.
   * Updating and simplyfing conditionals in package lists.
   * Allow to optionally run package installation in two passes.
     Eventually, this allows to have media containing a 'bigger' live
     system that what they end up installing (Closes: #627439).
Checksums-Sha1: 
 6790434c507b9834f5bf368839df636bf843a41d 1282 live-build_3.0~a20-1.dsc
 7f24fee7dad7eeba4add60f4fa81c03f94c7908b 1888244 live-build_3.0~a20.orig.tar.gz
 1fe427abaaef7f346804386285373f5165a91e13 41650 live-build_3.0~a20-1.debian.tar.gz
 d79b7295c2454c83fdda973544f5f60f5289df27 1129634 live-build_3.0~a20-1_all.deb
 7a0db396ac9518f4376c418f9871219fcd63b6b8 58120 live-build-cgi_3.0~a20-1_all.deb
Checksums-Sha256: 
 dc74db4c40a4966c3f710124e20e421b0308c69cc362ac9cfe8cfc4b45a7595a 1282 live-build_3.0~a20-1.dsc
 b227fd4be4088e948f8338c01c2cd79c5f0605670b91ba8d4c20607fc05618ad 1888244 live-build_3.0~a20.orig.tar.gz
 4c1bf5ab480e8788e9c3845abbe0a91b93bd981afa6276b171b7b524a6875202 41650 live-build_3.0~a20-1.debian.tar.gz
 ee20a677daf9178c2c0b0ad971283a33bd2fc8936cb82708787152ba861e5186 1129634 live-build_3.0~a20-1_all.deb
 02810265eb09b21b6bab18dae9c610fa573ba48252e76202130f43f211909ab2 58120 live-build-cgi_3.0~a20-1_all.deb
Files: 
 454c16e4f46d89d261a551c68e32efb9 1282 misc optional live-build_3.0~a20-1.dsc
 71d4d7a5dc10d9860271f7a44c2c2e0c 1888244 misc optional live-build_3.0~a20.orig.tar.gz
 8bb311d0c0268bb2d6c8239fdb239bdf 41650 misc optional live-build_3.0~a20-1.debian.tar.gz
 03d8db61043497cafe626020a5e311aa 1129634 misc optional live-build_3.0~a20-1_all.deb
 4eca7df09b82de4a8e3e016b1b61cb86 58120 misc optional live-build-cgi_3.0~a20-1_all.deb

-----BEGIN PGP SIGNATURE-----
Version: GnuPG v1.4.10 (GNU/Linux)

iEYEARECAAYFAk3zkRIACgkQ+C5cwEsrK56ciACeJFx0ZBHFgnIK5XBVF6ja6qbT
EeQAoIeUcXznnRfGPeZE87Z28PLkBioZ
=jpoN
-----END PGP SIGNATURE-----





Bug archived. Request was from Debbugs Internal Request <owner@bugs.debian.org> to internal_control@bugs.debian.org. (Sun, 10 Jul 2011 07:33:50 GMT) Full text and rfc822 format available.

Send a report that this bug log contains spam.


Debian bug tracking system administrator <owner@bugs.debian.org>. Last modified: Sat Apr 19 02:29:16 2014; Machine Name: beach.debian.org

Debian Bug tracking system
Copyright (C) 1999 Darren O. Benham, 1997,2003 nCipher Corporation Ltd, 1994-97 Ian Jackson.